SETENV(3)

NAME
setenv - change or add an environment variable

SYNOPSIS
#include <stdlib.h>

int setenv(const char *name, const char *value, int overwrite);

int unsetenv(const char *name);

DESCRIPTION
The setenv() function adds the variable name to the environment with the value value, if name does not already exist. If name does exist in the environment, then its value is changed to value if overwrite is non-zero; if overwrite is zero, then the value of name is not changed.

The unsetenv() function deletes the variable name from the environment.

RETURN VALUE
The setenv() function returns zero on success, or -1 if there was insufficient space in the environment. The unsetenv() function returns zero on success, or -1 on error, with errno set to indicate the cause of the error.

ERRORS

EINVAL
    name contained an '=' character.

CONFORMING TO
4.3BSD

NOTES
Prior to glibc 2.2.2, unsetenv() was prototyped as returning void; more recent glibc versions follow the SUSv3-compliant prototype shown in the SYNOPSIS.

BUGS
SUSv3 specifies that if name contains an '=' character, then setenv() should fail with the error EINVAL; however, versions of glibc before 2.3.4 allowed an '=' sign in name.

SEE ALSO
clearenv(3), getenv(3), putenv(3), environ(5)